#ifndef QCDNUMfw_H
#define QCDNUMfw_H

// Declarations for the Fortran/C interface
#include "QCDNUM/FortranWrappers.h"

extern "C" {


  /**************************************************************/
  /*  MBUTIL hash routines from hash.f                          */
  /**************************************************************/

  #define fimb_ihash FC_FUNC(imb_ihash,IMB_IHASH)
    int fimb_ihash(int*, int*, int*);
  #define fimb_jhash FC_FUNC(imb_jhash,IMB_JHASH)
    int fimb_jhash(int*, double*, int*);
  #define fimb_dhash FC_FUNC(imb_dhash,IMB_DHASH)
    int fimb_dhash(int*, double*, int*);

  /**************************************************************/
  /*  MBUTIL istore routines from istore.f                      */
  /**************************************************************/

  #define fsmb_iwinitcpp FC_FUNC(smb_iwinitcpp,SMB_IWINITCPP)
    void fsmb_iwinitcpp(int*, int*, char*, int*);
  #define fsmb_setiwn FC_FUNC(smb_setiwn,SMB_SETIWN)
    void fsmb_setiwn(int*, int*);
  #define fimb_iarray FC_FUNC(imb_iarray,IMB_IARRAY)
    int fimb_iarray(int*, int*, int*);
  #define fimb_iaread FC_FUNC(imb_iaread,IMB_IAREAD)
    int fimb_iaread(int*, int*, int*);
  #define fimb_daread FC_FUNC(imb_daread,IMB_DAREAD)
    int fimb_daread(int*, double*, int*);
  #define fsmb_iwwipe FC_FUNC(smb_iwwipe,SMB_IWWIPE)
    void fsmb_iwwipe(int*, int*);
  #define fimb_ihsize FC_FUNC(imb_ihsize,IMB_IHSIZE)
    int fimb_ihsize();

  #define fimb_isaistore FC_FUNC(imb_isaistore,IMB_ISAISTORE)
    int fimb_isaistore(int*);
  #define fimb_iwsize FC_FUNC(imb_iwsize,IMB_IWSIZE)
    int fimb_iwsize(int*);
  #define fimb_iwnused FC_FUNC(imb_iwnused,IMB_IWNUSED)
    int fimb_iwnused(int*);
  #define fimb_iwnarrays FC_FUNC(imb_iwnarrays,IMB_IWNARRAYS)
    int fimb_iwnarrays(int*);
  #define fimb_ialastobj FC_FUNC(imb_ialastobj,IMB_IALASTOBJ)
    int fimb_ialastobj(int*);
  #define fimb_iwnheader FC_FUNC(imb_iwnheader,IMB_IWNHEADER)
    int fimb_iwnheader(int*);
  #define fimb_iwobjecttype FC_FUNC(imb_iwobjecttype,IMB_IWOBJECTTYPE)
    int fimb_iwobjecttype(int*,int*);
  #define fimb_iwasize FC_FUNC(imb_iwasize,IMB_IWASIZE)
    int fimb_iwasize(int*,int*);
  #define fimb_iwanumber FC_FUNC(imb_iwanumber,IMB_IWANUMBER)
    int fimb_iwanumber(int*,int*);
  #define fimb_iwafprint FC_FUNC(imb_iwafprint,IMB_IWAFPRINT)
    int fimb_iwafprint(int*,int*);
  #define fimb_iwadim FC_FUNC(imb_iwadim,IMB_IWADIM)
    int fimb_iwadim(int*,int*);
  #define fimb_iwaimin FC_FUNC(imb_iwaimin,IMB_IWAIMIN)
    int fimb_iwaimin(int*,int*);
  #define fimb_iwaimax FC_FUNC(imb_iwaimax,IMB_IWAIMAX)
    int fimb_iwaimax(int*,int*);
  #define fimb_iaabegin FC_FUNC(imb_iaabegin ,IMB_IAABEGIN)
    int fimb_iaabegin(int*, int*);
  #define fimb_iaaend FC_FUNC(imb_iaaend ,IMB_IAAEND)
    int fimb_iaaend(int*, int*);
  #define fimb_iwknul FC_FUNC(imb_iwknul,IMB_IWKNUL)
    int fimb_iwknul(int*,int*);
  #define fimb_aiaddr FC_FUNC(imb_aiaddr ,IMB_AIADDR)
    int fimb_aiaddr(int*, int*, int*);
  #define fsmbiwtree FC_FUNC(smbiwtree ,SMBIWTREE)
    int fsmbiwtree(int*, int*);
  #define fsmb_iwhead FC_FUNC(smb_iwhead ,SMB_IWHEAD)
    int fsmb_iwhead(int*, int*);

  /**************************************************************/
  /*  MBUTIL character routines from mchar.f                    */
  /**************************************************************/

  #define fsmb_itochcpp FC_FUNC(smb_itochcpp,SMB_ITOCHCPP)
    void fsmb_itochcpp(int*, char*, int*, int*);
  #define fsmb_dtochcpp FC_FUNC(smb_dtochcpp,SMB_DTOCHCPP)
    void fsmb_dtochcpp(double*, int*, char*, int*, int*);
  #define fsmb_hcodecpp FC_FUNC(smb_hcodecpp,SMB_HCODECPP)
    void fsmb_hcodecpp(int*, char*, int*);

  /**************************************************************/
  /*  MBUTIL interpolation routines from polint.f               */
  /**************************************************************/

  #define fsmb_spline FC_FUNC(smb_spline,SMB_SPLINE)
    void fsmb_spline(int*, double*, double*, double*, double*, double*);
  #define fdmb_seval FC_FUNC(dmb_seval,DMB_SEVAL)
    double fdmb_seval(int*, double*, double*, double*, double*, double*, double*);

  /**************************************************************/
  /*  MBUTIL workspace routines from utils.f                    */
  /**************************************************************/

  #define fimb_version FC_FUNC(imb_version,IMB_VERSION)
    int fimb_version();

  /**************************************************************/
  /*  MBUTIL workspace routines from wspace.f                   */
  /**************************************************************/

  #define fimb_wsinitcpp FC_FUNC(imb_wsinitcpp,IMB_WSINITCPP)
    int fimb_wsinitcpp(double*, int*, int*, char*, int*);
  #define fsmb_setwsn FC_FUNC(smb_setwsn,SMB_SETWSN)
    void fsmb_setwsn(double*, int*);
  #define fimb_newset FC_FUNC(imb_newset,IMB_NEWSET)
    int fimb_newset(double*);
  #define fimb_wtable FC_FUNC(imb_wtable,IMB_WTABLE)
    int fimb_wtable(double*, int*, int*, int*);
  #define fimb_wclone FC_FUNC(imb_wclone,IMB_WCLONE)
    int fimb_wclone(double*, int*, double*);
  #define fsmb_tbcopy FC_FUNC(smb_tbcopy,SMB_TBCOPY)
    void fsmb_tbcopy(double*, int*, double*, int*, int*);
  #define fsmb_wswipe FC_FUNC(smb_wswipe,SMB_WSWIPE)
    void fsmb_wswipe(double*, int*);
  #define fsmb_tsdumpcpp FC_FUNC(smb_tsdumpcpp,SMB_TSDUMPCPP)
    void fsmb_tsdumpcpp(char*, int*, int*, double*, int*, int*);
  #define fimb_tsreadcpp FC_FUNC(imb_tsreadcpp,IMB_TSREADCPP)
    int fimb_tsreadcpp(char*, int*, int*, double*, int*);
  #define fsmb_wsmark FC_FUNC(smb_wsmark,SMB_WSMARK)
    void fsmb_wsmark(int*, int*, int*);
  #define fimb_hdsize FC_FUNC(imb_hdsize,IMB_HDSIZE)
    int fimb_hdsize();
  #define fimb_tbsize FC_FUNC(imb_tbsize,IMB_TBSIZE)
    int fimb_tbsize(int*, int*, int*);
  #define fimb_tpoint FC_FUNC(imb_tpoint,IMB_TPOINT)
    int fimb_tpoint(double*, int*, int*, int*);

  #define fimb_isaworkspace FC_FUNC(imb_isaworkspace,IMB_ISAWORKSPACE)
    int fimb_isaworkspace(double*);
  #define fimb_sizeofw FC_FUNC(imb_sizeofw,IMB_SIZEOFW)
    int fimb_sizeofw(double*);
  #define fimb_wordsused FC_FUNC(imb_wordsused,IMB_WORDSUSED)
    int fimb_wordsused(double*);
  #define fimb_nheader FC_FUNC(imb_nheader,IMB_NHEADER)
    int fimb_nheader(double*);
  #define fimb_ntags FC_FUNC(imb_ntags,IMB_NTAGS)
    int fimb_ntags(double*);
  #define fimb_headskip FC_FUNC(imb_headskip,IMB_HEADSKIP)
    int fimb_headskip(double*);
  #define fimb_iaroot FC_FUNC(imb_iaroot,IMB_IAROOT)
    int fimb_iaroot();
  #define fimb_iadrain FC_FUNC(imb_iadrain,IMB_IADRAIN)
    int fimb_iadrain(double*);
  #define fimb_ianull FC_FUNC(imb_ianull,IMB_IANULL)
    int fimb_ianull(double*);
  #define fimb_objecttype FC_FUNC(imb_objecttype,IMB_OBJECTTYPE)
    int fimb_objecttype(double*, int*);
  #define fimb_objectsize FC_FUNC(imb_objectsize,IMB_OBJECTSIZE)
    int fimb_objectsize(double*, int*);
  #define fimb_nobjects FC_FUNC(imb_nobjects,IMB_NOBJECTS)
    int fimb_nobjects(double*, int*);
  #define fimb_objectnumber FC_FUNC(imb_objectnumber,IMB_OBJECTNUMBER)
    int fimb_objectnumber(double*, int*);
  #define fimb_fingerprint FC_FUNC(imb_fingerprint,IMB_FINGERPRINT)
    int fimb_fingerprint(double*, int*);
  #define fimb_iafirsttag FC_FUNC(imb_iafirsttag,IMB_IAFIRSTTAG)
    int fimb_iafirsttag(double*, int*);
  #define fimb_tabledim FC_FUNC(imb_tabledim,IMB_TABLEDIM)
    int fimb_tabledim(double*, int*);
  #define fimb_iakarray FC_FUNC(imb_iakarray,IMB_IAKARRAY)
    int fimb_iakarray(double*, int*);
  #define fimb_iaimin FC_FUNC(imb_iaimin ,IMB_IAIMIN)
    int fimb_iaimin(double*, int*);
  #define fimb_iaimax FC_FUNC(imb_iaimax ,IMB_IAIMAX)
    int fimb_iaimax(double*, int*);
  #define fimb_begintbody FC_FUNC(imb_begintbody ,IMB_BEGINTBODY)
    int fimb_begintbody(double*, int*);
  #define fimb_endtbody FC_FUNC(imb_endtbody ,IMB_ENDTBODY)
    int fimb_endtbody(double*, int*);
  #define fimb_tfskip FC_FUNC(imb_tfskip ,IMB_TFSKIP)
    int fimb_tfskip(double*, int*);
  #define fimb_tbskip FC_FUNC(imb_tbskip ,IMB_TBSKIP)
    int fimb_tbskip(double*, int*);
  #define fimb_sfskip FC_FUNC(imb_sfskip ,IMB_SFSKIP)
    int fimb_sfskip(double*, int*);
  #define fimb_sbskip FC_FUNC(imb_sbskip ,IMB_SBSKIP)
    int fimb_sbskip(double*, int*);
  #define fsmbwstree FC_FUNC(smbwstree ,SMBWSTREE)
    int fsmbwstree(double*, int*);
  #define fsmb_wshead FC_FUNC(smb_wshead ,SMB_WSHEAD)
    int fsmb_wshead(double*, int*);

  /**************************************************************/
  /*  MBSPLINE routines from mbsInit.f                          */
  /**************************************************************/

  #define fsbs_init FC_FUNC(sbs_init,IMS_INIT)
    void fsbs_init();

  /**************************************************************/
  /*  SPLINT routines from usrsplint.f                          */
  /**************************************************************/

  #define fisp_spvers FC_FUNC(isp_spvers,ISP_SPVERS)
    int fisp_spvers();
  #define fssp_spinit FC_FUNC(ssp_spinit,SSP_SPINIT)
    void fssp_spinit(int*);
  #define fssp_uwrite FC_FUNC(ssp_uwrite,SSP_UWRITE)
    void fssp_uwrite(int*, double*);
  #define fdsp_uread FC_FUNC(dsp_uread,DSP_UREAD)
    double fdsp_uread(int*);
  #define fisp_sxmake FC_FUNC(isp_sxmake,ISP_SXMAKE)
    int fisp_sxmake(int*);
  #define fisp_sxuser FC_FUNC(isp_sxuser,ISP_SXUSER)
    int fisp_sxuser(double *, int*);
  #define fssp_sxfill FC_FUNC(ssp_sxfill,SSP_SXFILL)
    void fssp_sxfill(int*, double (*)(int*,int*,bool*), int*);
  #define fssp_sxfpdf FC_FUNC(ssp_sxfpdf,SSP_SXFPDF)
    void fssp_sxfpdf(int*, int*, double*, int*, int*);
  #define fssp_sxf123 FC_FUNC(ssp_sxf123,SSP_SXF123)
    void fssp_sxf123(int*, int*, double*, int*, int*);
  #define fisp_sqmake FC_FUNC(isp_sqmake,ISP_SQMAKE)
    int fisp_sqmake(int*);
  #define fisp_squser FC_FUNC(isp_squser,ISP_SQUSER)
    int fisp_squser(double *, int*);
  #define fssp_sqfill FC_FUNC(ssp_sqfill,SSP_SQFILL)
    void fssp_sqfill(int*, double (*)(int*,int*,bool*), int*);
  #define fssp_sqfpdf FC_FUNC(ssp_sqfpdf,SSP_SQFPDF)
    void fssp_sqfpdf(int*, int*, double*, int*, int*);
  #define fssp_sqf123 FC_FUNC(ssp_sqf123,SSP_SQF123)
    void fssp_sqf123(int*, int*, double*, int*, int*);
  #define fdsp_funs1 FC_FUNC(dsp_funs1,DSP_FUNS1)
    double fdsp_funs1(int*,double*,int*);
  #define fdsp_ints1 FC_FUNC(dsp_ints1,DSP_INTS1)
    double fdsp_ints1(int*,double*,double*);
  #define fisp_s2make FC_FUNC(isp_s2make,ISP_S2MAKE)
    int fisp_s2make(int*, int*);
  #define fisp_s2user FC_FUNC(isp_s2user,ISP_s2user)
    int fisp_s2user(double*, int*, double*, int*);
  #define fssp_s2fill FC_FUNC(ssp_s2fill,SSP_S2FILL)
    void fssp_s2fill(int*, double (*)(int*,int*,bool*), double*);
  #define fssp_s2fpdf FC_FUNC(ssp_s2fpdf,SSP_S2FPDF)
    void fssp_s2fpdf(int*, int*, double*, int*, double*);
  #define fssp_s2f123 FC_FUNC(ssp_s2f123,SSP_S2F123)
    void fssp_s2f123(int*, int*, double*, int*, double*);
  #define fdsp_funs2 FC_FUNC(dsp_funs2,DSP_FUNS2)
    double fdsp_funs2(int*,double*,double*,int*);
  #define fdsp_ints2 FC_FUNC(dsp_ints2,DSP_INTS2)
    double fdsp_ints2(int*,double*,double*,double*,double*,double*,int*);
  #define fssp_extrapu FC_FUNC(ssp_extrapu,SSP_EXTRAPU)
    void fssp_extrapu(int*, int*);
  #define fssp_extrapv FC_FUNC(ssp_extrapv,SSP_EXTRAPV)
    void fssp_extrapv(int*, int*);
  #define fisp_splinetype FC_FUNC(isp_splinetype,ISP_SPLINETYPE)
    int fisp_splinetype(int*);
  #define fssp_splims FC_FUNC(ssp_splims,SSP_SPLIMS)
    void fssp_splims(int*, int*, double*, double*, int*, double*, double*, int*);
  #define fssp_unodes FC_FUNC(ssp_unodes,SSP_UNODES)
    void fssp_unodes(int*, double*, int*, int*);
  #define fssp_vnodes FC_FUNC(ssp_vnodes,SSP_VNODES)
    void fssp_vnodes(int*, double*, int*, int*);
  #define fssp_nprint FC_FUNC(ssp_nprint,SSP_NPRINT)
    void fssp_nprint(int*);
  #define fdsp_rscut FC_FUNC(dsp_rscut,DSP_RSCUT)
    double fdsp_rscut(int*);
  #define fdsp_rsmax FC_FUNC(dsp_rsmax,DSP_RSMAX)
    double fdsp_rsmax(int*,double*);
  #define fssp_mprint FC_FUNC(ssp_mprint,SSP_MPRINT)
    void fssp_mprint();
  #define fisp_spsize FC_FUNC(isp_spsize,ISP_SPSIZE)
    int fisp_spsize(int*);
  #define fssp_erase FC_FUNC(ssp_erase,SSP_ERASE)
    void fssp_erase(int*);
  #define fssp_spdumpcpp FC_FUNC(ssp_spdumpcpp,SSP_SPDUMPCPP)
    void fssp_spdumpcpp(int*,char*,int*);
  #define fisp_spreadcpp FC_FUNC(isp_spreadcpp,ISP_SPREADCPP)
    int fisp_spreadcpp(char*,int*);
  #define fssp_spsetval FC_FUNC(ssp_spsetval,SSP_SPSETVAL)
    void fssp_spsetval(int*,int*,double*);
  #define fdsp_spgetval FC_FUNC(dsp_spgetval,DSP_SPGETVAL)
    double fdsp_spgetval(int*,int*);

  /**************************************************************/
  /*  TOOLBOX init routines from tbx00ini.f                     */
  /**************************************************************/

  #define ftbx_wsinit FC_FUNC(tbx_wsinit,TBX_WSINIT)
    void ftbx_wsinit(double*, int*);

  /**************************************************************/
  /*  QCDNUM evolution routines from usrevol.f                  */
  /**************************************************************/

  #define frfromf FC_FUNC(rfromf,RFROMF)
    double frfromf(double*);
  #define fffromr FC_FUNC(ffromr,FFROMR)
    double fffromr(double*);
  #define fasfunc FC_FUNC(asfunc,ASFUNC)
    double fasfunc(double*, int*, int*);
  #define faltabn FC_FUNC(altabn,ALTABN)
    double faltabn(int*, int*, int*, int*);
  #define fevolfg FC_FUNC(evolfg,EVOLFG)
    void fevolfg(int*, double (*)(int* ,double*), double*, int*, double*);
  #define fevsgns FC_FUNC(evsgns,EVSGNS)
    void fevsgns(int*, double (*)(int* ,double*), int*, int*, int*, double*);
  #define fpdfcpy FC_FUNC(pdfcpy,PDFCPY)
    void fpdfcpy(int*, int*);
  #define fextpdf FC_FUNC(extpdf,EXTPDF)
    void fextpdf(double (*)(int*, double* ,double* ,bool*), int*, int*, double*, double*);
  #define fusrpdf FC_FUNC(usrpdf,USRPDF)
    void fusrpdf(double (*)(int*, double* ,double* ,bool*), int*, int*, double*, double*);
  #define fnptabs FC_FUNC(nptabs,NPTABS)
    int fnptabs(int*);
  #define fievtyp FC_FUNC(ievtyp,IEVTYP)
    int fievtyp(int*);

  /**************************************************************/
  /*  QCDNUM grid routines from usrgrd.f                        */
  /**************************************************************/

  #define fgxmake FC_FUNC(gxmake,GXMAKE)
    void fgxmake(double*, int*, int*, int*, int*, int*);
  #define fixfrmx FC_FUNC(ixfrmx,IXFRMX)
    int fixfrmx(double*);
  #define fxxatix FC_FUNC(xxatix,XXATIX)
    int fxxatix(double*, int*);
  #define fxfrmix FC_FUNC(xfrmix,XFRMIX)
    double fxfrmix(int*);
  #define fgxcopy FC_FUNC(gxcopy,GXCOPY)
    void fgxcopy(double*, int*, int*);
  #define fgqmake FC_FUNC(gqmake,GQMAKE)
    void fgqmake(double*, double*, int*, int*, int*);
  #define fiqfrmq FC_FUNC(iqfrmq,IQFRMQ)
    int fiqfrmq(double*);
  #define fqqatiq FC_FUNC(qqatiq,QQATIQ)
    int fqqatiq(double*, int*);
  #define fqfrmiq FC_FUNC(qfrmiq,QFRMIQ)
    double fqfrmiq(int*);
  #define fgqcopy FC_FUNC(gqcopy,GQCOPY)
    void fgqcopy(double*, int*, int*);
  #define fgrpars FC_FUNC(grpars,GRPARS)
    void fgrpars(int*, double*, double*, int*, double*, double*, int*);
  #define fsetlim FC_FUNC(setlim,SETLIM)
    void fsetlim(int*, int*, int*, double*);
  #define fgetlim FC_FUNC(getlim,GETLIM)
    void fgetlim(int*, double*, double*, double*, double*);

  /**************************************************************/
  /*  QCDNUM init routines from usrini.f                        */
  /**************************************************************/

  #define fqcinitcpp FC_FUNC(qcinitcpp,QCINITCPP)
    void fqcinitcpp(int*, char*, int*);
  #define fsetluncpp FC_FUNC(setluncpp,SETLUNCPP)
    void fsetluncpp(int*, char*, int*);
  #define fnxtlun FC_FUNC(nxtlun,NXTLUN)
    int fnxtlun(int*);
  #define fsetvalcpp FC_FUNC(setvalcpp,SETVALCPP)
    void fsetvalcpp(char*, int*, double*);
  #define fgetvalcpp FC_FUNC(getvalcpp,GETVALCPP)
    void fgetvalcpp(char*, int*, double*);
  #define fsetintcpp FC_FUNC(setintcpp,SETINTCPP)
    void fsetintcpp(char*, int*, int*);
  #define fgetintcpp FC_FUNC(getintcpp,GETINTCPP)
    void fgetintcpp(char*, int*, int*);
  #define fqstorecpp FC_FUNC(qstorecpp,QSTORECPP)
    void fqstorecpp(char*, int*, int*, double*);

  /**************************************************************/
  /*  QCDNUM parameter routines from usrparams.f                */
  /**************************************************************/

  #define fsetord FC_FUNC(setord,SETORD)
    void fsetord(int*);
  #define fgetord FC_FUNC(getord,GETORD)
    void fgetord(int*);
  #define fsetalf FC_FUNC(setalf,SETALF)
    void fsetalf(double*, double*);
  #define fgetalf FC_FUNC(getalf,GETALF)
    void fgetalf(double*, double*);
  #define fsetcbt FC_FUNC(setcbt,SETCBT)
    void fsetcbt(int*, int*, int*, int*);
  #define fmixfns FC_FUNC(mixfns,MIXFNS)
    void fmixfns(int*, double*, double*, double*);
  #define fgetcbt FC_FUNC(getcbt,GETCBT)
    void fgetcbt(int*, double*, double*, double*);
  #define fsetabr FC_FUNC(setabr,SETABR)
    void fsetabr(double*, double*);
  #define fgetabr FC_FUNC(getabr,GETABR)
    void fgetabr(double*, double*);
  #define fnfrmiq FC_FUNC(nfrmiq,NFRMIQ)
    int fnfrmiq(int*, int*, int*);
  #define fnflavs FC_FUNC(nflavs,NFLAVS)
    int fnflavs(int*, int*);
  #define fcpypar FC_FUNC(cpypar,CPYPAR)
    void fcpypar(double*, int*, int*);
  #define fusepar FC_FUNC(usepar,USEPAR)
    void fusepar(int*);
  #define fkeypar FC_FUNC(keypar,KEYPAR)
    int fkeypar(int*);
  #define fkeygrp FC_FUNC(keygrp,KEYGRP)
    int fkeygrp(int*, int*);
  #define fpushcp FC_FUNC(pushcp,PUSHCP)
    void fpushcp();
  #define fpullcp FC_FUNC(pullcp,PULLCP)
    void fpullcp();

  /**************************************************************/
  /*  QCDNUM pdf output routines from usrpdf.f                  */
  /**************************************************************/

  #define fallfxq FC_FUNC(allfxq,ALLFXQ)
    void fallfxq(int*, double*, double*, double*, int*, int*);
  #define fallfij FC_FUNC(allfij,ALLFIJ)
    void fallfij(int*, int*, int*, double*, int*, int*);
  #define fbvalxq FC_FUNC(bvalxq,BVALXQ)
    double fbvalxq(int*, int*, double*, double*, int*);
  #define fbvalij FC_FUNC(bvalij,BVALIJ)
    double fbvalij(int*, int*, int*, int*, int*);
  #define ffvalxq FC_FUNC(fvalxq,FVALXQ)
    double ffvalxq(int*, int*, double*, double*, int*);
  #define ffvalij FC_FUNC(fvalij,FVALIJ)
    double ffvalij(int*, int*, int*, int*, int*);
  #define fsumfxq FC_FUNC(sumfxq,SUMFXQ)
    double fsumfxq(int*, double*, int*, double*, double*, int*);
  #define fsumfij FC_FUNC(sumfij,SUMFIJ)
    double fsumfij(int*, double*, int*, int*, int*, int*);
  #define ffsplne FC_FUNC(fsplne,FSPLNE)
    double ffsplne(int*, int*, double*, int*);
  #define fsplchk FC_FUNC(splchk,SPLCHK)
    double fsplchk(int*, int*, int*);
  #define ffflist FC_FUNC(fflist,FFLIST)
   void ffflist(int*, double*, int*, double*, double*, double*, int*, int*);
  #define ffftabl FC_FUNC(fftabl,FFTABL)
   void ffftabl(int*, double*, int*, double*, int*, double*, int*, double*, int*, int*);
  #define fftable FC_FUNC(ftable,FTABLE)
   void fftable(int*, double*, int*, double*, int*, double*, int*, double*, int*);
  #define fffplotcpp FC_FUNC(ffplotcpp,FFPLOTCPP)
    void fffplotcpp(char*, int*, double (*)(int*, double*, bool*), int*, double*,  double*, int*, char*, int*);
  #define ffiplotcpp FC_FUNC(fiplotcpp,FIPLOTCPP)
    void ffiplotcpp(char*, int*, double (*)(int*, double*, bool*), int*, double*, int*, char*, int*);

  /**************************************************************/
  /*  QCDNUM weight routines from usrwgt.f                      */
  /**************************************************************/

  #define ffillwt FC_FUNC(fillwt,FILLWT)
    void ffillwt(int*, int*, int*, int*);
  #define fdmpwgtcpp FC_FUNC(dmpwgtcpp,DMPWGTCPP)
    void fdmpwgtcpp(int*, int*, char*, int*);
  #define freadwtcpp FC_FUNC(readwtcpp,READWTCPP)
    void freadwtcpp(int*, char*, int*, int*, int*, int*, int*);
  #define fwtfilecpp FC_FUNC(wtfilecpp,WTFILECPP)
    void fwtfilecpp(int*, char*, int*);
  #define fnwused FC_FUNC(nwused,NWUSED)
    void fnwused(int*, int*, int*);

  /**************************************************************/
  /*  HQSTF routines                                            */
  /**************************************************************/

  #define fhqwords FC_FUNC(hqwords,HQWORDS)
    void fhqwords(int*, int*);
  #define fhqparms FC_FUNC(hqparms,HQPARMS)
    void fhqparms(double*, double*, double*);
  #define fhqqfrmu FC_FUNC(hqqfrmu,HQQFRMU)
    double fhqqfrmu(double*);
  #define fhqmufrq FC_FUNC(hqmufrq,HQMUFRQ)
    double fhqmufrq(double*);
  #define fhswitch FC_FUNC(hswitch,HSWITCH)
    void fhswitch(int*);
  #define fhqstfun FC_FUNC(hqstfun,HQSTFUN)
    void fhqstfun(int*, int*, double*, double*, double*, double*, int*, int*);
  #define fhqfillw FC_FUNC(hqfillw,HQFILLW)
    void fhqfillw(int*, double*, double*, double*, int*);
  #define fhqdumpwcpp FC_FUNC(hqdumpwcpp,HQDUMPWCPP)
    void fhqdumpwcpp(int*, char*, int*);
  #define fhqreadwcpp FC_FUNC(hqreadwcpp,HQREADWCPP)
    void fhqreadwcpp(int*, char*, int*, int*, int*);

  /**************************************************************/
  /*  ZMSTF routines                                            */
  /**************************************************************/

  #define fizmvers FC_FUNC(izmvers,IZMVERS)
    int fizmvers();
  #define fzmwords FC_FUNC(zmwords,ZMWORDS)
    void fzmwords(int*, int*);
  #define fzmdefq2 FC_FUNC(zmdefq2,ZMDEFQ2)
    void fzmdefq2(double*, double*);
  #define fzmabval FC_FUNC(zmabval,ZMABVAL)
    void fzmabval(double*, double*);
  #define fzmqfrmu FC_FUNC(zmqfrmu,ZMQFRMU)
    double fzmqfrmu(double*);
  #define fzmufrmq FC_FUNC(zmufrmq,ZMUFRMQ)
    double fzmufrmq(double*);
  #define fzswitch FC_FUNC(zswitch,ZSWITCH)
    void fzswitch(int*);
  #define fzmstfun FC_FUNC(zmstfun,ZMSTFUN)
    void fzmstfun(int*, double*, double*, double*, double*, int*, int*);
  #define fzmfillw FC_FUNC(zmfillw,ZMFILLW)
    void fzmfillw(int*);
  #define fzmdumpwcpp FC_FUNC(zmdumpwcpp,ZMDUMPWCPP)
    void fzmdumpwcpp(int*, char*, int*);
  #define fzmreadwcpp FC_FUNC(zmreadwcpp,ZMREADWCPP)
    void fzmreadwcpp(int*, char*, int*, int*, int*);
  #define fzmwfilecpp FC_FUNC(zmwfilecpp,ZMWFILECPP)
    void fzmwfilecpp(char*,int*);
}

#endif

